# Хөл бөмбөгийн цэнгэлдэх хүрээлэн

Нагейрдо нь Дебрецен хотод байх квадрат хэлбэртэй ширэнгэн ой бөгөөд $N \times N$  нүдтэй хүснэгтээр загварчилж болно.
Хүснэгтийн мөрийг хойноос урагш $0$ -ээс $N - 1$, баганыг баруунаас зүүн тийш нь $0$ -ээс $N - 1$ хүртэл тус тус дугаарлая.
Бид хүснэгтийн $r$ мөр болон $c$ багана дахь нүдийг $(r, c)$ гэж тэмдэглэнэ.

Ширэнгийн нүд бүр нь **хоосон** эсвэл **мод**-той байна. Ширэнгэд ядаж нэг хоосон нүд бий.

Тус хотын алдартай DVSC спорт клуб ширэнгэд хөлбөмбөгийн шинэ цэнгэлдэх хүрээлэн барихаар төлөвлөжээ.

Цэнгэлдэх хүрээлэнгийн хэмжээ нь $s$ ($s \ge 1$) гэдэг нь $(r_0, c_0), \ldots, (r_{s - 1}, c_{s - 1})$ *ялгаатай хоосон* нүднүүдийн олонлог юм.
Энэ нь
- $0$-ээс $s - 1$-ийн хооронд байх $i$ бүрийн хувьд (захын утгуудыг оруулна) $(r_i, c_i)$ нүд хоосон 
-  $0 \le i \lt j \lt s$ байх $i$, $j$ бүрийн хувьд $r_i \neq r_j$ ба $c_i \neq c_j$-ий 1-ийн дор хаяж нэг нь биелэдэг байна.

Хөл бөмбөгчин цэнгэлдэх хүрээлэнгийн нүднүүдийн эргэн тойронд бөмбөг ашиглан тоглоно. **Шулуун цохилт** нь дараах хоёр үйлдлийн аль нэгээр тодорхойлогдоно:
* бөмбөгийг $(r,a)$ нүднээс $(r,b)$  нүд ($0 \le r,a,b \lt N, a \ne b$) рүү өшиглөсөн гэвэл бөмбөг нь цэнгэлдэх хүрээлэнгийн $r$ мөрний  $(r,a)$ нүднээс $(r,b)$ нүд хүртлэх *бүх* нүдээр дайрна. Энэ нь:
 - Хэрэв $a \lt b$ бол $k$ ($a \le k \le b$) байх $k$ бүрийн хувьд $(r,k)$ нүднүүдийг цэнгэлдэх хүрээлэн агуулна,
 - Хэрэв $a \gt b$ бол $b \le k \le a$ байх $k$ бүрийн хувьд $(r,k)$ нүднүүдийг цэнгэлдэх хүрээлэн агуулна.
* Бөмбөгийн $(a,c)$ нүднээс $(b,c)$ нүд ($0 \le c,a,b \lt N, a \ne b$) рүү бөмбөгийг өшиглөсөн гэвэл  $c$ баганын $(a,c)$-ээс $(b,c)$ хүртэлх *бүх* нүдийг дайрна. Энэ нь:
 - хэрэв $a \lt b$ бол $a \le k \le b$ байх $k$ бүрийн хувьд $(k,c)$ нүдийг цэнгэлдэх хүрээлэн агуулна,
 - хэрэв $a \gt b$ бол $b \le k \le a$ байх $k$ бүрийн хувьд $(k,c)$ нүдийг цэнгэлдэх хүрээлэн агуулна.

Цэнгэлдэх хүрээлэнгийн аль ч нүднээс бөмбөгийг бусад нүд рүү хамгийн ихдээ 2 шулуун цохилтоор шилжүүлэх боломжтой бол цэнгэлдэх хүрээлэнг **хэвийн** гэнэ.
Мөн 1 хэмжээтэй цэнгэлдэх хүрээлэнг хэвийн гэж үзнэ.  

Жишээ, $N = 5$ хэмжээтэй $(1,0)$, $(4,2)$ нүднүүд нь модтой, бусад нь хоосон ширэнгэ байна гэе.
Доорх зурагт байж болох гурван цэнгэлдэх хүрээлэнг харуулав. Хараар модтой нүдийг, зураасаар цэнгэлдэх хүрээлэнгийн агуулж буй нүднүүдийг тэмдэглэв.
 
![Stadiums](soccer-regular.png "650")

Зүүн талын цэнгэлдэх хүрээлэн нь хэвийн. Дунд талын цэнгэлдэх бол хэвийн биш. Учир нь, $(4,1)$-ээс $(4,3)$ нүд рүү хамгийн багадаа 3 шулуун цохилт хийх хэрэгтэй болно. Баруун талын цэнгэлдэх хүрээлэн нь мөн хэвийн биш. Учир нь бөмбөгийг шулуун цохилтоор $(3,0)$ -ээс $(1,3)$ нүд рүү  өшиглөх боломжгүй. 
Спорт клуб байж болох хамгийн том хэмжээтэй хэвийн цэнгэлдэх хүрээлэн байгуулахыг хүсэж байгаа. 
Таны даалгавар бол ширэнгэ дотор байгуулах *s* хэмжээтэй хэвийн цэнгэлдэх хүрээлэнгийн хамгийн их утга болох *s*-ийг олох явдал юм. 

## Хэрэгжүүлэлтийн мэдээлэл

Та дараах процедурыг бичиж хэрэгжүүлнэ.

```
int biggest_stadium(int N, int[][] F)
```

* $N$: ширэнгийн хэмжээ.
* $F$: $N$ элементтэй массивыг агуулсан $N$ элементтэй массив байх ба ширэнгийн нүднүүдийг тодорхойлно. $0 \le r \lt N$ ба $0 \le c \lt N$ байх $r$ ба $c$ бүрийн хувьд $F[r][c] = 0$ бол  $(r, c)$ нүд хоосон, бусад үед $F[r][c] = 1$ байх ба нүд нь мод агуулсан гэсэн үг.
* Энэ процедур нь ширэнгэд барьж болох хэвийн цэнгэлдэх хүрээлэнгийн хамгийн их хэмжээг буцаах ёстой.
* Энэ процедурыг тестийн тохиолдол бүрд яг нэг удаа дуудна.

## Жишээ

Дараах дуудалтыг хийсэн гэе:

```
biggest_stadium(5, [[0, 0, 0, 0, 0],  
                    [1, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 1, 0, 0]])
```

Энэ жишээнд зүүн талын зурганд ширэнгийн модыг, баруун талын зурагт $20$ хэмжээтэй хэвийн цэнгэлдэх хүрээлэнг дүрсэлжээ:

![Example](soccer-example.png "400")

$21$ болон түүнээс их хэмжээтэй хэвийн цэнгэлдэх хүрээлэн байгуулах боломжгүй ба процедур нь $20$ гэсэн утгыг буцаана.

## Хязгаарлалт

* $1 \le N \le  2\,000$
* $0 \le F[i][j] \le 1$ ($0 \le i \lt N$ ба $0 \le j \lt N$ байх $i$ болон $j$ бүрийн хувьд)
* Ширэнгэд дор хаяж нэг хоосон нүд байна. Өөрөөр хэлбэл,  $0 \le i \lt N$ ба $0 \le j \lt N$ байх зарим утгын хувьд $F[i][j] = 0$ байна.

## Дэд бодлогоууд

1. (6 оноо) Мод агуулсан нүд хамгийн багадаа нэг байгаа. 
2. (8 оноо) $N \le 3$
3. (22 оноо) $N \le 7$ 
4. (18 оноо) $N \le 30$ 
5. (16 оноо) $N \le 500$
6. (30 оноо) Нэмэлт хязгаарлалт байхгүй.

Хэрэв таны программ нийт хоосон нүднүүдээс бүрдэх муж нь хэвийн цэнгэлдэх хүрээлэн мөн эсэхийг зөв тодорхойлсон тохиолдолд дэд бодлого бүрийн тухайн дэд бодлогын онооны 25%-ийг авах боломжтой.

Тодруулбал, бүх хоосон нүднүүдээс бүрдэх муж нь хэвийн цэнгэлдэх хүрээлэн байх тест бүрийн хувьд таны шийдэл:
- хэрэв зөв хариулт буцаавал бүтэн оноо авна (энэ нь бүх хоосон нүднүүдээс бүрдэх мужийн хэмжээ).
- бусад үед 0 оноо авна.

Бүх хоосон нүднүүдээс бүрдэх муж нь *хэвийн биш* цэнгэлдэх хүрээлэн байх тестийн тохиолдол бүрийн хувьд таны шийдэл нь:
* зөв хариулт өгсөн тохиолдолд бүтэн оноо авна.
* хэрэв бүх хоосон нүднүүдээс бүрдэх мужийн хэмжээг буцаавал 0 оноо авна.
* Хэрэв өөр утгыг буцаавал онооны 25%-ийг авна.

Дэд бодлого бүрийн оноо гэдэг нь тухайн дэд бодлогын тестийн тохиолдлуудын хамгийн бага оноо юм.

## Жишээ грейдер

Жишээ грейдер нь дараах форматын дагуу оролтыг уншина. 
 
* Мөр $1$: $N$
* Мөр $2 + i$  ($0 \le i \lt N$):  $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$
 
Жишээ грейдер нь гаралтыг дараах форматын дагуу хэвлэнэ.
* Мөр $1$: `biggest_stadium` процедурын буцаах утга
